org.firstinspires.ftc.robotcore.external.navigation

## Enum AxesOrder

- java.lang.Object
- - java.lang.Enum<AxesOrder>
  - - org.firstinspires.ftc.robotcore.external.navigation.AxesOrder

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<AxesOrder>

      public enum AxesOrder
      extends java.lang.Enum<AxesOrder>

  `AxesOrder` indicates the chronological order of axes about which the three rotations of an `Orientation` take place. The geometry of three space is such that there are exactly twelve distinct rotational orders.
  See Also:
    `Orientation`, `AxesReference`, Euler Angles

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `XYX`
    `XYZ`
    `XZX`
    `XZY`
    `YXY`
    `YXZ`
    `YZX`
    `YZY`
    `ZXY`
    `ZXZ`
    `ZYX`
    `ZYZ`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Axis[]` | `axes()` Returns the `axes` associated with this `AxesOrder`.
    `int[]` | `indices()` Returns the numerical axes indices associated with this `AxesOrder`.
    `AxesOrder` | `reverse()` Returns the `AxesOrder` which is the chronological reverse of the receiver.
    `static AxesOrder` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static AxesOrder[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### XZX

          public static final AxesOrder XZX

    - #### XYX

          public static final AxesOrder XYX

    - #### YXY

          public static final AxesOrder YXY

    - #### YZY

          public static final AxesOrder YZY

    - #### ZYZ

          public static final AxesOrder ZYZ

    - #### ZXZ

          public static final AxesOrder ZXZ

    - #### XZY

          public static final AxesOrder XZY

    - #### XYZ

          public static final AxesOrder XYZ

    - #### YXZ

          public static final AxesOrder YXZ

    - #### YZX

          public static final AxesOrder YZX

    - #### ZYX

          public static final AxesOrder ZYX

    - #### ZXY

          public static final AxesOrder ZXY

  - ### Method Detail

    - #### values

          public static AxesOrder[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AxesOrder c : AxesOrder.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AxesOrder valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### indices

          public int[] indices()

      Returns the numerical axes indices associated with this `AxesOrder`.
      Returns:
        the numerical axes indices associated with this `AxesOrder`.

    - #### axes

          public Axis[] axes()

      Returns the `axes` associated with this `AxesOrder`.
      Returns:
        the `axes` associated with this `AxesOrder`.

    - #### reverse

          public AxesOrder reverse()

      Returns the `AxesOrder` which is the chronological reverse of the receiver.
      Returns:
        the `AxesOrder` which is the chronological reverse of the receiver.